package demo
/**
* 商业地产
*/
import (
	"fmt"
	"strings"
	"net/url"
	"net/http"
	"io/ioutil"
)

//楼栋新增
func AddBuilding(param CommercialBuilding, token string) {
	//请求参数
	var params = url.Values{
		"city_name": {param.CityName},
		"district_name": {param.DistrictName},
		"resblock_name": {param.ResblockName},
		"building_name": {param.BuildingName},
		"address": {param.Address},
		"stat_usage": {param.StatUsage},
		"trade_owner": {param.TradeOwner},
		"resblock_lat": {param.ResblockLat},
		"resblock_lng": {param.ResblockLng},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/Open/In/Building/Add",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用商业地产出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

type CommercialBuilding struct{
	CityName string
	DistrictName string
	ResblockName string
	BuildingName string
	Address string
	StatUsage string
	TradeOwner string
	ResblockLat string
	ResblockLng string
}