package main
/**
*房e估
*/
import (
	"fmt"
	"strings"
	"net/url"
	"net/http"
	"io/ioutil"
	"encoding/json"
)

//获取token使用的appKey和appSecret
var appKey = "appKey";
var appSecret = "appSecret";

//房e估
func AccessPrice(param AccessPriceParam, token string) {
	//请求参数
	var params = url.Values{
		"assessType": {param.AssessType},
		"identifier": {param.Identifier},
		"standPriceAssessBuildArea": {param.StandPriceAssessBuildArea},
		"standDetailedAddress": {param.StandDetailedAddress},
		"standCity": {param.StandCity},
		"cityGbCode": {param.CityGbCode},
		"standDistrictAndCounty": {param.StandDistrictAndCounty},
		"standResblock": {param.StandResblock},
		"standBuilding": {param.StandBuilding},
		"standUnit": {param.StandUnit},
		"standFloor": {param.StandFloor},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/api/assessPrice",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用房e估出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

//获取token
func GetToken() string {
	//请求参数
	params := url.Values{
		"grant_type": {"client_credentials"},
		"client_id": {appKey},
		"client_secret": {appSecret},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/oauth/token",
		strings.NewReader(params.Encode()))
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        return ""
    }
	defer resp.Body.Close()
	body, _ := ioutil.ReadAll(resp.Body)
	var res Response
	json.Unmarshal([]byte(body), &res)
	return res.Data.AccessToken
}

//返回的token数据结构
type Token struct {
	AccessToken string `json:"access_token"`
	RefreshToken string `json:"refresh_token"`
	TokenType string `json:"token_type"`
	ExpiresIn string `json:"expires_in"`
	Scope string `json:"scope"`
}
type Response struct {
	Code int32 `json:"code"`
	Msg string `json:"msg"`
	Data Token `json:"data"`
}

//房e估参数
type AccessPriceParam struct{
	AssessType string
	Identifier string
	StandPriceAssessBuildArea string
	StandDetailedAddress string
	StandCity string
	CityGbCode string
	StandDistrictAndCounty string
	StandResblock string
	StandBuilding string
	StandUnit string
	StandFloor string
}

func main() {
	var token string
	token = GetToken()
	fun(token)
}

//房e估
func fun(token string) {
	var accessPriceParam AccessPriceParam
	accessPriceParam.AssessType = "AUTO_TO_ARTIFICIAL_ASSESS"
	accessPriceParam.Identifier = "1djiuduf"
	accessPriceParam.StandPriceAssessBuildArea = "66.3"
	accessPriceParam.StandDetailedAddress = "北京市昌平区回龙观镇龙乡小区东区14号楼1单元601"
	accessPriceParam.StandCity = "北京市"
	accessPriceParam.CityGbCode = "110000"
	accessPriceParam.StandDistrictAndCounty = "昌平区"
	accessPriceParam.StandResblock = "龙乡小区东区"
	accessPriceParam.StandBuilding = "14号楼"
	accessPriceParam.StandUnit = "1单元"
	accessPriceParam.StandFloor = "6层"
	AccessPrice(accessPriceParam, token)
}