package main
/**
* 图片验真
*/
import (
	"fmt"
	"strings"
	"net/url"
	"net/http"
	"io/ioutil"
	"encoding/json"
)

//获取token使用的appKey和appSecret
var appKey = "appKey";
var appSecret = "appSecret";

//图片验真
func PictureVerify(param PictureVerifyParam, token string) {
	//请求参数
	var params = url.Values{
		"type": {param.Type},
		"cityName": {param.CityName},
		"address": {param.Address},
		"district": {param.District},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/api/images-distinguish/distinguish",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用图片验真出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

//获取token
func GetToken() string {
	//请求参数
	params := url.Values{
		"grant_type": {"client_credentials"},
		"client_id": {appKey},
		"client_secret": {appSecret},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/oauth/token",
		strings.NewReader(params.Encode()))
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        return ""
    }
	defer resp.Body.Close()
	body, _ := ioutil.ReadAll(resp.Body)
	var res Response
	json.Unmarshal([]byte(body), &res)
	return res.Data.AccessToken
}

//返回的token数据结构
type Token struct {
	AccessToken string `json:"access_token"`
	RefreshToken string `json:"refresh_token"`
	TokenType string `json:"token_type"`
	ExpiresIn string `json:"expires_in"`
	Scope string `json:"scope"`
}
type Response struct {
	Code int32 `json:"code"`
	Msg string `json:"msg"`
	Data Token `json:"data"`
}

//图片验真参数
type PictureVerifyParam struct{
	Type string
	Address string
	CityName string
	District string
	Image string
}

func main() {
	var token string
	token = GetToken()
	fun(token)
}

//图片验真
func fun(token string) {
	var pictureVerifyParam PictureVerifyParam
	pictureVerifyParam.Type = "2"
	pictureVerifyParam.Address = "北京市昌平区回龙观镇龙乡小区东区14号楼1单元601"
	pictureVerifyParam.CityName = "北京市"
	pictureVerifyParam.District = "昌平区"
	PictureVerify(pictureVerifyParam, token)
}