package main
/**
* 房屋验真-实勘验真
*/
import (
	"fmt"
	"strings"
	"net/url"
	"net/http"
	"io/ioutil"
	"encoding/json"
)

//获取token使用的appKey和appSecret
var appKey = "appKey";
var appSecret = "appSecret";

//下单前判断
func CheckPrivilege(param CheckPrivilegeParam, token string) {
	//请求参数
	var params = url.Values{
		"cityName": {param.CityName},
		"districtName": {param.DistrictName},
		"resblockName": {param.ResblockName},
		"buildingName": {param.BuildingName},
		"unitName": {param.UnitName},
		"houseName": {param.HouseName},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/api/images-distinguish/order/checkPrivilege",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用实勘验真出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

//获取token
func GetToken() string {
	//请求参数
	params := url.Values{
		"grant_type": {"client_credentials"},
		"client_id": {appKey},
		"client_secret": {appSecret},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/oauth/token",
		strings.NewReader(params.Encode()))
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        return ""
    }
	defer resp.Body.Close()
	body, _ := ioutil.ReadAll(resp.Body)
	var res Response
	json.Unmarshal([]byte(body), &res)
	return res.Data.AccessToken
}

//返回的token数据结构
type Token struct {
	AccessToken string `json:"access_token"`
	RefreshToken string `json:"refresh_token"`
	TokenType string `json:"token_type"`
	ExpiresIn string `json:"expires_in"`
	Scope string `json:"scope"`
}
type Response struct {
	Code int32 `json:"code"`
	Msg string `json:"msg"`
	Data Token `json:"data"`
}

//实勘验真参数
type CheckPrivilegeParam struct{
	CityName string
	DistrictName string
	ResblockName string
	BuildingName string
	UnitName string
	HouseName string
}


func main() {
	var token string
	token = GetToken()
	fun(token)
}

//实勘验真
func fun(token string) {
	var CheckPrivilegeParam CheckPrivilegeParam
	CheckPrivilegeParam.CityName = "北京市"
	CheckPrivilegeParam.DistrictName = "海淀区"
	CheckPrivilegeParam.ResblockName = "龙腾苑二区"
	CheckPrivilegeParam.BuildingName = "13号楼"
	CheckPrivilegeParam.UnitName = "5单元"
	CheckPrivilegeParam.HouseName = "101"
	CheckPrivilege(CheckPrivilegeParam, token)
}