package main
/**
* 成交案例库
*/
import (
	"fmt"
	"strings"
	"net/url"
	"net/http"
	"io/ioutil"
	"encoding/json"
)

//获取token使用的appKey和appSecret
var appKey = "appKey";
var appSecret = "appSecret";

//成交案例库
func DealExample(param DealExampleParam, token string) {
	//请求参数
	var params = url.Values{
		"standCity": {param.StandCity},
		"standPriceAssessBuildArea": {param.StandPriceAssessBuildArea},
		"standDetailedAddress": {param.StandDetailedAddress},
		"timePeriod": {param.TimePeriod},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/api/assessTransactionCase",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用成交案例库出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

//获取token
func GetToken() string {
	//请求参数
	params := url.Values{
		"grant_type": {"client_credentials"},
		"client_id": {appKey},
		"client_secret": {appSecret},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/oauth/token",
		strings.NewReader(params.Encode()))
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        return ""
    }
	defer resp.Body.Close()
	body, _ := ioutil.ReadAll(resp.Body)
	var res Response
	json.Unmarshal([]byte(body), &res)
	return res.Data.AccessToken
}

//返回的token数据结构
type Token struct {
	AccessToken string `json:"access_token"`
	RefreshToken string `json:"refresh_token"`
	TokenType string `json:"token_type"`
	ExpiresIn string `json:"expires_in"`
	Scope string `json:"scope"`
}
type Response struct {
	Code int32 `json:"code"`
	Msg string `json:"msg"`
	Data Token `json:"data"`
}

//成交案例库参数
type DealExampleParam struct{
	StandCity string
	StandPriceAssessBuildArea string
	StandDetailedAddress string
	TimePeriod string
}


func main() {
	var token string
	token = GetToken()
	fun(token)
}

//成交案例库
func fun(token string) {
	var dealExampleParam DealExampleParam
	dealExampleParam.StandCity = "重庆市"
	dealExampleParam.StandPriceAssessBuildArea = "99.01"
	dealExampleParam.StandDetailedAddress = "重庆市龙湖春森彼岸四期"
	dealExampleParam.TimePeriod = "LAST_THREE_MONTH"
	DealExample(dealExampleParam, token)
}