package main
/**
* 房本识别
*/
import (
	"fmt"
	"strings"
	"net/url"
	"net/http"
	"io/ioutil"
	"encoding/base64"
	"encoding/json"
)

//获取token使用的appKey和appSecret
var appKey = "appKey";
var appSecret = "appSecret";

//房本识别--url
func HouseCertUrl(param HouseCertParam, token string) {
	//请求参数
	var params = url.Values{
		"imgUrl": {param.ImgUrl},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/api/ocr/houseCert",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用房本识别出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

//房本识别--Base64
func HouseCertBase64(param HouseCertParam, token string) {
	//请求参数
	var params = url.Values{
		"imgBase64": {param.ImgBase64},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/api/ocr/houseCert",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用房本识别出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

//把图片转换成base64编码
func ConvertFileToBase64(path string) string {
	image, _:= ioutil.ReadFile(path)
	imageBase64 := base64.StdEncoding.EncodeToString(image)
	return imageBase64
}

//获取token
func GetToken() string {
	//请求参数
	params := url.Values{
		"grant_type": {"client_credentials"},
		"client_id": {appKey},
		"client_secret": {appSecret},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/oauth/token",
		strings.NewReader(params.Encode()))
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        return ""
    }
	defer resp.Body.Close()
	body, _ := ioutil.ReadAll(resp.Body)
	var res Response
	json.Unmarshal([]byte(body), &res)
	return res.Data.AccessToken
}

//返回的token数据结构
type Token struct {
	AccessToken string `json:"access_token"`
	RefreshToken string `json:"refresh_token"`
	TokenType string `json:"token_type"`
	ExpiresIn string `json:"expires_in"`
	Scope string `json:"scope"`
}
type Response struct {
	Code int32 `json:"code"`
	Msg string `json:"msg"`
	Data Token `json:"data"`
}

//房本识别的请求参数
type HouseCertParam struct{
	ImgUrl string
	ImgBase64 string
}

func main() {
	var token string
	token = GetToken()
	fun(token)
}
//房本识别
func fun(token string) {
	var houseCertParam HouseCertParam
	houseCertParam.ImgUrl = "https://s1.ljcdn.com/transaction-public-static/tradeBrain/static/fangben-1-detect.png"
	HouseCertUrl(houseCertParam, token)
	houseCertParam.ImgBase64 = ConvertFileToBase64("/Users/fengyadong/fangben-1-detect.png")
	HouseCertBase64(houseCertParam, token)
}