package main
/**
* 房本验真
*/
import (
	"fmt"
	"strings"
	"net/url"
	"net/http"
	"io/ioutil"
	"encoding/json"
)

//获取token使用的appKey和appSecret
var appKey = "appKey";
var appSecret = "appSecret";

//房本验真
func HouseBookVerify(param HouseBookVerifyParam, token string) {
	//请求参数
	var params = url.Values{
		"cityName": {param.CityName},
		"cityAddress": {param.CityAddress},
		"housePerson": {param.HousePerson},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/api/houseBook/credibility",
		strings.NewReader(params.Encode()))
	//设置请求header
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	req.Header.Add("access_token",token)
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        fmt.Println("调用房本验真出错")
    }
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))
}

//获取token
func GetToken() string {
	//请求参数
	params := url.Values{
		"grant_type": {"client_credentials"},
		"client_id": {appKey},
		"client_secret": {appSecret},
	}
	//请求地址
	req, _ := http.NewRequest(http.MethodPost,
		"https://gw-open.ke.com/oauth/token",
		strings.NewReader(params.Encode()))
	req.Header.Add("Content-Type","application/x-www-form-urlencoded")
	resp, err := http.DefaultClient.Do(req)
	if err != nil {
        return ""
    }
	defer resp.Body.Close()
	body, _ := ioutil.ReadAll(resp.Body)
	var res Response
	json.Unmarshal([]byte(body), &res)
	return res.Data.AccessToken
}

//返回的token数据结构
type Token struct {
	AccessToken string `json:"access_token"`
	RefreshToken string `json:"refresh_token"`
	TokenType string `json:"token_type"`
	ExpiresIn string `json:"expires_in"`
	Scope string `json:"scope"`
}
type Response struct {
	Code int32 `json:"code"`
	Msg string `json:"msg"`
	Data Token `json:"data"`
}

//房本验真参数
type HouseBookVerifyParam struct{
	CityName string
	CityAddress string
	HousePerson string
}


func main() {
	var token string
	token = GetToken()
	fun(token)
}

//房本验真
func fun(token string) {
	var houseBookVerifyParam HouseBookVerifyParam
	houseBookVerifyParam.CityName = "北京市"
	houseBookVerifyParam.CityAddress = "北京市昌平区回龙观镇龙乡小区东区14号楼1单元601"
	houseBookVerifyParam.HousePerson = "[{\"name\":\"周芷若\"}]"
	HouseBookVerify(houseBookVerifyParam, token)
}