<?php
/**
 * 商房直连
 */
class CommercialHouse{
    
    /**
     * 使用时替换appKey和appSecret
     */
    private $domain = "https://gw-open.ke.com";
    private $appKey = "appKey";
    private $appSecret = "appSecret";

    /**
     * 楼栋新增
     */
    function addBuilding($token,$param){
        $url = $this->domain."/Open/In/Building/Add";
        $header = array("access_token:{$token}");
        $ret = $this->posturl($url,$param,$header);
        return $ret;
    }

    /**
     * 获取token
     */
   function getToken(){
        $tokenUrl = $this->domain."/oauth/token";
        $param = array(
            "grant_type" => "client_credentials",
            "client_id" => $this->appKey,
            "client_secret" => $this->appSecret,
        );
        $ret = $this->posturl($tokenUrl,$param);
        if($ret["code"] != 0){
            return false;
        }else{
        return $ret["data"]["access_token"];
        }
    }

    /**
     * get请求
     */
    private function geturl($url,$header = array()){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($ch);
        curl_close($ch);
        $output = json_decode($output,true);
        return $output;
    }

    /**
     * post请求
     */
    private function posturl($url,$data,$header=array()){
        $data = http_build_query($data, '', '&'); 
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

        curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($curl);
        curl_close($curl);
        return json_decode($output,true);
    }
}
   

$cc = new CommercialHouse();
$token = $cc->getToken();
if($token == false){
    echo "token获取失败";
    die;
}

//商房直连
$param = array(
    "city_name" => "北京市",
    "district_name" => "海淀区",
    "resblock_name" => "弘源首著大厦",
    "building_name" => "1号楼",
    "address" => "xzl",
    "trade_owner" => "notreal",
    "stat_usage" => "昌平区",
    "resblock_lat" => "40.049317",
    "resblock_lng" => "116.311989",
);
$data = $cc->addBuilding($token,$param);
print_r($data);

?>