<?php
/**
 * 户型解读
 */
class HouseFrameReport{
    
    /**
     * 使用时替换appKey和appSecret
     */
    private $domain = "https://gw-open.ke.com";
    private $appKey = "appKey";
    private $appSecret = "appSecret";

    /**
     * 户型解读
     */
    function frameReport($token,$param){
        $url = $this->domain."/api/frame_report/eval?frame_id=".$param;
        $header = array("access_token:{$token}");
        $ret = $this->geturl($url,$header);
        return $ret;
    }

    /**
     * 获取token
     */
   function getToken(){
        $tokenUrl = $this->domain."/oauth/token";
        $param = array(
            "grant_type" => "client_credentials",
            "client_id" => $this->appKey,
            "client_secret" => $this->appSecret,
        );
        $ret = $this->posturl($tokenUrl,$param);
        if($ret["code"] != 0){
            return false;
        }else{
        return $ret["data"]["access_token"];
        }
    }

    /**
     * get请求
     */
    private function geturl($url,$header = array()){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($ch);
        curl_close($ch);
        $output = json_decode($output,true);
        return $output;
    }

    /**
     * post请求
     */
    private function posturl($url,$data,$header=array()){
        $data = http_build_query($data, '', '&'); 
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($curl);
        curl_close($curl);
        return json_decode($output,true);
    }
}
   

$cc = new HouseFrameReport();
$token = $cc->getToken();
if($token == false){
    echo "token获取失败";
    die;
}

//户型解读
$param = "1116734796657371";
$data = $cc->frameReport($token,$param);
print_r($data);

?>