<?php
/**
 * 房本识别
 */
class HouseCert{
    
    /**
     * 使用时替换appKey和appSecret
     */
    private $domain = "https://gw-open.ke.com";
    private $appKey = "appKey";
    private $appSecret = "appSecret";

    /**
     * 房本识别
     */
    function ocrCert($token,$param){
        $url = $this->domain."/api/ocr/houseCert";
        $header = array("access_token:{$token}");
        $ret = $this->posturl($url,$param,$header);
        return $ret;
    }

    /**
     * 获取token
     */
   function getToken(){
        $tokenUrl = $this->domain."/oauth/token";
        $param = array(
            "grant_type" => "client_credentials",
            "client_id" => $this->appKey,
            "client_secret" => $this->appSecret,
        );
        $ret = $this->posturl($tokenUrl,$param);
        if($ret["code"] != 0){
            return false;
        }else{
        return $ret["data"]["access_token"];
        }
    }
    
    /**
     * get请求
     */
    private function geturl($url,$header = array()){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($ch);
        curl_close($ch);
        $output = json_decode($output,true);
        return $output;
    }

    /**
     * post请求
     */
    private function posturl($url,$data,$header=array()){
        $data = http_build_query($data, '', '&'); 
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

        curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($curl);
        curl_close($curl);
        return json_decode($output,true);
    }

    /**
     * 图片转base64
     * */
    function convertFileToBase64 ($image_file) {
        $base64_image = '';
        $image_info = getimagesize($image_file);
        $image_data = fread(fopen($image_file, 'r'), filesize($image_file));
        $base64_image = base64_encode($image_data);
        return $base64_image;
      }
}
   

$cc = new HouseCert();
$token = $cc->getToken();
if($token == false){
    echo "token获取失败";
    die;
}

//房本识别--使用房本地址
$param = array(
            "imgUrl" => "https://s1.ljcdn.com/transaction-public-static/tradeBrain/static/fangben-1-detect.png"
        );

$data = $cc->ocrCert($token,$param);
print_r($data);
//房本识别--使用base64编码
$img = '/Users/fengyadong/fangben-1-detect.png';
$base64_img = $cc->convertFileToBase64($img);
$param2 = array(
    "imgBase64" => $base64_img
);
$data2 = $cc->ocrCert($token,$param2);
print_r($data2);

?>