<?php
/**
 * 房本验真
 */
class HouseBookVerify{

    /**
     * 使用时替换appKey和appSecret
     */
    private $domain = "https://gw-open.ke.com";
    private $appKey = "appKey";
    private $appSecret = "appSecret";

    /**
     * 房本验真
     */
    function verify($token,$param){
        $url = $this->domain."/api/houseBook/credibility";
        $header = array("access_token:{$token}");
        $ret = $this->posturl($url,$param,$header);
        return $ret;
    }

    /**
     * 获取token
     */
   function getToken(){
        $tokenUrl = $this->domain."/oauth/token";
        $param = array(
            "grant_type" => "client_credentials",
            "client_id" => $this->appKey,
            "client_secret" => $this->appSecret,
        );
        $ret = $this->posturl($tokenUrl,$param);
        if($ret["code"] != 0){
            return false;
        }else{
            return $ret["data"]["access_token"];
        }
    }

    /**
     * get请求
     */
    private function geturl($url,$header = array()){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($ch);
        curl_close($ch);
        $output = json_decode($output,true);
        return $output;
    }
    
    /**
     * post请求
     */
    private function posturl($url,$data,$header=array()){
        $data = http_build_query($data, '', '&'); 
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

        curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
        $output = curl_exec($curl);
        curl_close($curl);
        return json_decode($output,true);
    }
}
   

$cc = new HouseBookVerify();
$token = $cc->getToken();
if($token == false){
    echo "token获取失败";
    die;
}

//房本验真
$param = array(
            "cityAddress" => "北京市昌平区回龙观镇龙乡小区东区14号楼1单元601",
            "cityName" => "北京市",
            "housePerson" => "[{\"name\":\"周芷若\"}]"
        );
$data = $cc->verify($token,$param);
print_r($data);

?>