from ._svc_call import _SvcCall 


PROPERTIES = (
'assessType',
'identifier',
'standPriceAssessBuildArea',
'standDetailedAddress',
'standCity')

URI = '/api/assessPrice'

class Param:
    def __init__(self, **kw):
        self.params = {}
        for prop in PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params


class AssessPriceSvc(_SvcCall):
    """
    房e估服务
    """

    def __init__(self, **kw):
        super().__init__(**kw)
    
    def assess_price(self, param: Param): 
        """
        估价接口
        """
        return self._post(URI, param)