from ._svc_call import _SvcCall 

ADD_BUILDING_PROPERTIES = (
    'city_name',
    'district_name',
    'resblock_name',
    'building_name',
    'address',
    'stat_usage',
    'trade_owner',
    'resblock_lat',
    'resblock_lng'
)

ADD_XZLRENT_PROPERTIES = (
    'building_id',
    'delegation_code',
    'unit',
    'floor',
    'house_name',
    'build_area',
    'price',
    'is_c_show',
    'status'
)

UPDATE_XZLRENT_PROPERTIES = (
    'house_code'
)

RESBLOCK_ALL_PROPERTIES = (
    'app_id',
    'city_name'
)

BUILDING_LIST_PROPERTIES = (
    'app_id',
    'city_name',
    'resblock_id'
)

ADD_HOUSE_PROPERTIES = (
    'app_id',
    'partner_house_id',
    'city_name',
    'resblock_id',
    'building_id',
    'delegation_code',
    'floor',
    'house_name',
    'build_area'
)

UPDATE_HOUSE_PROPERTIES = (
    'app_id',
    'house_code',
    'partner_house_id',
    'delegation_code',
    'floor',
    'house_name',
    'build_area',
    'can_cutting',
    'min_cutting_size',
    'min_hold_count',
    'max_hold_count',
    'fitment',
    'showing_time',
    'total_price',
    'total_price_unit',
    'price',
    'price_unit',
    'available_time',
    'pay_count',
    'deposit_count',
    'lease_term',
    'lease_unit',
    'images',
    'status',
    'version'
)

UPDATE_RESBLOCK_PROPERTIES = (
    'app_id',
    'resblock_id',
    'resblock_images',
    'brokerage_detail',
    'contact_list'
)

HOUSE_ONLINE_PROPERTIES = (
    'app_id',
    'house_code',
    'online_status'
)

ADD_BUILDING_URI = '/Open/In/Building/Add'
ADD_XZLRENT_URI = '/Open/In/House/Addxzlrent'
UPDATE_XZLRENT_URI = '/Open/In/House/Updatexzlrent'
RESBLOCK_ALL_URI = '/open/resource/resblock/all'
BUILDING_LIST_URI = '/open/resource/building/list'
ADD_HOUSE_URI = '/open/resource/house/add'
UPDATE_HOUSE_URI = '/open/resource/house/update'
UPDATE_RESBLOCK_URI = '/open/resource/resblock/update'
HOUSE_ONLINE_URI = '/open/resouce/house/online'

class AddBuildingParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in ADD_BUILDING_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class AddXZLRentParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in ADD_XZLRENT_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params


class UpdateXZLRentParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in UPDATE_XZLRENT_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class ResblockAllParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in RESBLOCK_ALL_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class BuildingListParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in BUILDING_LIST_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class AddHouseParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in ADD_HOUSE_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class UpdateHouseParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in UPDATE_HOUSE_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class UpdateResblockParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in UPDATE_RESBLOCK_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class HouseOnlineParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in HOUSE_ONLINE_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params



class CommercialHouseSvc(_SvcCall):
    """
    商房直连服务
    """
    def __init__(self, **kw):
        super().__init__(**kw)
    
    def add_building(self, param: AddBuildingParam):
        """
        楼栋新增
        """
        return self._post(ADD_BUILDING_URI, param)
    
    def add_xzlrent(self, param: AddXZLRentParam):
        """
        新增写字楼租赁房间
        """
        return self._post(ADD_XZLRENT_URI, param)

    def update_xzlrent(self, param: UpdateXZLRentParam):
        """
        修改写字楼租赁房间
        """
        return self._post(UPDATE_XZLRENT_URI, param)

    def resblock_all(self, param: ResblockAllParam):
        """
        获取所有楼盘数据
        """
        return self._post(RESBLOCK_ALL_URI, param)

    def building_list(self, param: BuildingListParam):
        """
        获取楼栋列表
        """
        return self._post(BUILDING_LIST_URI, param)

    def add_house(self, param: AddHouseParam):
        """
        房源新增
        """
        return self._post(ADD_HOUSE_URI, param)

    def update_house(self, param: UpdateHouseParam):
        """
        房源编辑
        """
        return self._post(UPDATE_HOUSE_URI, param)
    
    def update_resblock(self, param: UpdateResblockParam):
        """
        楼盘信息更新
        """
        return self._post(UPDATE_RESBLOCK_URI, param)

    def house_online(self, param: HouseOnlineParam):
        """
        房源上下架
        """
        return self._post(HOUSE_ONLINE_URI, param)
    
    