from ._svc_call import _SvcCall 
import base64

URI = '/api/ocr/houseCert'


class HouseCertSvc(_SvcCall):
    """
    房产证识别
    """
    def __init__(self, **kw):
        super().__init__(**kw)
    
    def certify(self, img_url): 
        """
        房产证识别--url
        """
        return self._post(URI, {'imgUrl': img_url})

    def certify_base64(self, img_base64): 
        """
        房产证识别--base64
        """
        return self._post(URI, {'imgBase64': img_base64})

    def convert_file_to_base64(self, path):
        with open(path, 'rb') as f:
            image_data = f.read()
            base64_data = base64.b64encode(image_data)
            return base64_data