from ._svc_call import _SvcCall 

DATA_VERIFY_PROPERTIES = (
    'address',
    'cityName', 
    'district'
)

HOUSEINFO_URI = '/api/images-distinguish/houseInfo'

class DataVerifyParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in DATA_VERIFY_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("缺少参数: %s" % (prop))
    
        self.__dict__ = self.params

class HouseDataVerifySvc(_SvcCall):
    """
    房屋验真--数据验真
    """
    def __init__(self, **kw):
        super().__init__(**kw)
    
    def verify_data(self, param: DataVerifyParam): 
        """
        数据验真接口
        """
        return self._post(HOUSEINFO_URI, param)