from ._svc_call import _SvcCall 


IMAGE_VERIFY_PROPERTIES = (
    'type',
    'address',
    'cityName',
    'district'
)

DISTINGUISH_URI = '/api/images-distinguish/distinguish'


class ImageVerifyParam:
    def __init__(self, **kw):
        self.params = {}
        for prop in IMAGE_VERIFY_PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class HousePictureVerifySvc(_SvcCall):
    """
    房屋验真--图片验真
    """
    def __init__(self, **kw):
        super().__init__(**kw)
    
    def verify_image(self, param: ImageVerifyParam):
        """
        图片验真接口
        """
        return self._post(DISTINGUISH_URI, param)