from ._svc_call import _SvcCall 



PROPERTIES = (
    'cityName', 
    'cityAddress',
    'housePerson'
)


URI = '/api/houseBook/credibility'

class Param:
    def __init__(self, **kw):
        self.params = {}
        for prop in PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params


class HousebookVerifySvc(_SvcCall):
    """
    房本验真服务
    """
    def __init__(self, **kw):
        super().__init__(**kw)
    
    def certify(self, param: Param): 
        """
        房本验真接口
        """
        return self._post(URI, param)
    