from ._svc_call import _SvcCall 

PROPERTIES = (
    'assessType',
    'identifier',
    'standPriceAssessBuildArea',
    'standDetailedAddress',
    'standCity',
    'cityGbCode',
    'standDistrictAndCounty',
    'standResblock',
    'standBuilding',
    'standUnit',
    'standHouse'
)

PREJUDGE_URI = '/api/assessPriceReportPrejudge'
APPLY_URI = '/api/assessPriceReportApply'
PROGRESS_URI = '/api/assessPriceReportProgress'
REPORT_URI = '/api/assessPriceReport'

class Param:
    def __init__(self, **kw):
        self.params = {}
        for prop in PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class PriceReportSvc(_SvcCall):
    """
    房屋价值分析报告服务
    """
    def __init__(self, **kw):
        super().__init__(**kw)
    
    def price_report_pre(self, param: Param):
        """
        房屋价值分析报告接口--预判
        """
        return self._post(PREJUDGE_URI, param)
    
    def price_report_apply(self, param: Param):
        """
        房屋价值分析报告接口--申请
        """
        return self._post(APPLY_URI, param)

    def price_report_progress(self, param: Param):
        """
        房屋价值分析报告接口--进度
        """
        return self._post(PROGRESS_URI, param)

    def price_report_detail(self, param: Param):
        """
        房屋价值分析报告接口--获取
        """
        return self._post(REPORT_URI, param)
    
    