from ._svc_call import _SvcCall 

PROPERTIES = (
    'assessType',
    'identifier',
    'standPriceAssessBuildArea',
    'standDetailedAddress',
    'standCity',
    'cityGbCode',
    'standDistrictAndCounty',
    'standResblock',
    'standBuilding',
    'standUnit',
    'standHouse'
)

URI = '/api/synAssessPriceAndRisk'

class Param:
    def __init__(self, **kw):
        self.params = {}
        for prop in PROPERTIES:
            if prop in kw:
                self.params[prop] = kw[prop]
            else:
                raise NameError("未知参数: %s" % (prop))
    
        self.__dict__ = self.params

class PrcieRiskSvc(_SvcCall):
    """
    房屋押品监控服务
    """
    def __init__(self, **kw):
        super().__init__(**kw)
    
    def price_risk(self, param: Param):
        """
        房屋押品监控接口
        """
        return self._post(URI, param)